<template>
  <div>
    <section class="content">
      <h1>YouTube Converter.</h1>
      <p>Converting and downloading YouTube videos to MP3</p>
      <form @submit.prevent="download">
        <div class="input-wrap">
          <input
            type="text"
            id="url-input"
            name="url"
            class="input form-control"
            v-model="url"
          />
          <label for="url-input">Video URL</label>
        </div>
        <div class="input-wrap">
          <input
            type="submit"
            id="submit"
            name="Download"
            class="input form-control"
          />
        </div>
      </form>
    </section>

    <section class="background">
      <img id="circle" src="/img/Ellipse.svg" />
      <img id="square" src="/img/square.svg" />
      <img id="square_small" src="/img/square_small.svg" />
      <img id="triangle" src="/img/triangle.svg" />
    </section>
  </div>
</template>

<script>
import { ref } from "vue";
import { log } from "@/utils";
import { setLoading } from "@/services/modal";
import { downloadVideo } from "@/services/video";

export default {
  name: "Home",
  setup() {
    const url = ref("");
    const download = async () => {
      try {
        setLoading();
        const videoUrl = encodeURIComponent(url.value);
        await downloadVideo({ url: videoUrl });
      } catch (error) {
        log({ message: error });
        setModalMessage({ title: "Something went wrong", message: error });
      } finally {
        url.value = "";
        setLoading({ open: false });
      }
    };

    return {
      url,
      download,
    };
  },
};
</script>
